/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void QConfigForm::open_directory()
{
      QString s = QFileDialog::getExistingDirectory(
	    "/",
                    this,
                    "open file dialog",
	    "Choose a file to open",TRUE );
    lib_folders->insertItem(s);
}

void QConfigForm::remove_directory()
{
    int index_folder=lib_folders->currentItem();
    lib_folders->removeItem(index_folder);
}

void QConfigForm::start_indexing()
{
    save_configuration();
    QProcess  *doodle;   
    doodle = new QProcess( this ) ; 
    doodle->addArgument( "doodle");
    doodle->addArgument( "-b");
    int number_items = lib_folders->numItemsVisible();
     for  (int i = 0; i<=number_items;i++)
    {
    doodle->addArgument(lib_folders->text(i));    
     }
    qbusyform->setmsg("Busy indexing");
    qbusyform->show();
    doodle->start(); 
    this->setCursor(QCursor(Qt::WaitCursor));
    emit started("Indexing started");
    emit start();
    btn_start_index->setEnabled(false);
    btn_add_directory->setEnabled(false);
    btn_remove_directory->setEnabled(false);
    btn_reread_config->setEnabled(false);
    btn_cancel_index->setEnabled(true);    
    lib_folders->setEnabled(false);    
    connect( btn_cancel_index,SIGNAL(clicked()),doodle, SLOT(kill()) );
    connect( doodle,SIGNAL(processExited()),this, SLOT(enable_input()) );
}

void QConfigForm::enable_input()
{
    emit indexing_stopped("Indexing stopped");    
    emit stop();
    btn_start_index->setEnabled(true);
    btn_cancel_index->setEnabled(false);
    btn_add_directory->setEnabled(true);
    btn_remove_directory->setEnabled(true);
    btn_reread_config->setEnabled(true);   
    lib_folders->setEnabled(true);
    qbusyform->hide();
   this->setCursor(QCursor(Qt::ArrowCursor));    
}

void QConfigForm::open_configuration()
{
    lib_folders->clear();
    QString config_dir = QDir::homeDirPath();
    config_dir.append("/.KDoodle/");
    QDir cf(config_dir);
    if (!cf.exists())
    {
         cf.mkdir(config_dir);
     }     
     config_dir.append("config.lst");
     QFile config(config_dir);
     if ( config.exists())
     {
     config.open( IO_ReadOnly );
     QTextStream stream( &config);
     QString line;
        while ( !stream.atEnd() ) {
        line = stream.readLine(); 
	if (line!="")
	{
	     lib_folders->insertItem(line);
	 }
        } 
     config.close(); 
     }
 }

void QConfigForm::save_configuration()
{
    QString config_dir = QDir::homeDirPath();
    config_dir.append("/.KDoodle/");
    QDir cf(config_dir);
    if (!cf.exists())
    {
         cf.mkdir(config_dir);
     }
     config_dir.append("config.lst");
     QFile config(config_dir);
     config.open( IO_WriteOnly | IO_Truncate );
     QTextStream stream( &config);
     int number_items = lib_folders->numItemsVisible();
     for  (int i = 0; i<=number_items;i++)
    {
    QString select_dir=lib_folders->text(i);    
    stream << select_dir <<"\n";
     }  
     config.close(); 
  }




void QConfigForm::init()
{
    qbusyform = new QBusyForm(this);
    qbusyform->hide();
}
