/*****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
void QKdoodle::init()
{
    searchform = new QSearchForm(this);
    searchform ->move(QPoint(10,25));
    configform = new QConfigForm(this);
    configform ->move(QPoint(10,25));
    configform->hide();
    connect( configform,SIGNAL(started(const QString &)),this, SLOT(update_status(const QString &)) );
    connect( configform,SIGNAL(start()),this, SLOT(disable_all()) );    
    connect( searchform,SIGNAL(search_start()),this, SLOT(disable_all()) );   
    connect( configform,SIGNAL(indexing_stopped(const QString&)),this, SLOT(update_status(const QString &)) );
     connect( configform,SIGNAL(stop()),this, SLOT(enable_all()) );
     connect( searchform,SIGNAL(search_stopped()),this, SLOT(enable_all()) );     
    connect( searchform,SIGNAL(file_selected(const QString &)),this, SLOT(update_status(const QString &)) );
    connect( searchform,SIGNAL(reset_hit(const QString &)),this, SLOT(update_status(const QString &)) );
    statusBar()->message("Ready");
}

void QKdoodle::show_help()
{
    QMessageBox::about( this ,"KDoodle Help","To use KDoodle, one must first create an index through the config section. Once an index in created ,\nyou can search for your values. Each result can be selected and open with an associated program");
}

void QKdoodle::show_about()
{
    QMessageBox::about( this ,"KDoodle About","KDoodle is a frontend build for doodle. A graphical interface built on a cli indexing tool. \nThis is developped as a learning process for me in QT and C++. One can contact me on countcobolt@c2root.be");
}

void QKdoodle::show_version()
{
    QMessageBox::about( this ,"KDoodle Version","Version 0.2.2");
}
void QKdoodle::show_license()
{
    QMessageBox::about( this ,"KDoodle License","KDoodle 0.2.2 : A Doodle Frontend.\nCopyright (C) 2006 Steve \"Countcobolt\" Caster (countcobolt@c2root.be) \n\nThis program is free software; you can redistribute it and/or\nmodify it under the terms of the GNU General Public License\nas published by the Free Software Foundation; either version 2\nof the License, or (at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program; if not, write to the Free Software\nFoundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.\n");
}
void QKdoodle::show_widget()
{
    configform->hide();
    searchform->show();
    statusBar()->message("Search screen opened");
}

void QKdoodle::show_config()
{
    searchform->hide();
    configform->show();
    connect(this,SIGNAL(reread_config()),configform,SLOT(open_configuration()));
    emit reread_config();
    statusBar()->message("Configuration screen opened");
}

void QKdoodle::update_status(const QString &s)
{
    statusBar()->message(s);
}

void QKdoodle::enable_all()
{
    MenuBarEditor->setEnabled(true);
    
}

void QKdoodle::disable_all()
{
    MenuBarEditor->setEnabled(false);
    
}
