/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


/*Slot used when looking for the program to open file with*/
void QOpenFile::Select_program()
{
    QString p=QFileDialog::getOpenFileName("/home","Any files (*)",this,"Openfile dialog","Choose program to  use");
    txt_program->setText(p);
}


/*slots that sees if the value in the lineEdit to select the program is executable*/
void QOpenFile::changed_program(const QString &p)
{
    QFileInfo program(p);
    if (program.isExecutable() && !(program.isDir()))
	btn_open->setEnabled(true);
    else
	btn_open->setEnabled(false);
}

/*slot used to set the file named passed by an external argument*/
void QOpenFile::set_file( const QString &s)
{
   txt_file->setText(s);
   QFileInfo file_type(s);
   txt_extension->setText(file_type.extension());
   use_program();
}


void QOpenFile::run_program()
{
    QString file=txt_file->text();
    program = txt_program->text();
    kshell=new QProcess(this);
    kshell->addArgument("kshell");
    kshell->addArgument(program);
    kshell->addArgument(file);    
    kshell->start();
    if (chk_save->isChecked())
	save_association();
    txt_program->clear();
    hide();
}

void QOpenFile::use_program()
{
   QString extension=txt_extension->text();
   QString file_types_file= QDir::homeDirPath();
   file_types_file.append("/.KDoodle/assc.lst");
   
   QFile types(file_types_file);
   if (types.exists())
   {
   types.open(IO_ReadOnly);
   QTextStream stream(&types);
   QString line;
   while (!stream.atEnd() )
       {
       line = stream.readLine();
       QString ftype=line.section(':',0,0);
       QString fprogram=line.section(':',1,1); 
       if (ftype==extension)
                   {
                   txt_program->setText(fprogram);
	//   run_program();
		   /*when running through this function it appears that the software is going crazy and opening up several processes*/
                   chk_save->setEnabled(false);
 	   show();
	   break;
	   }
       else
                  {
                  chk_save->setEnabled(true);
	   show();
                   }
       }
    }
   else
   {
       show();
   }
}

void QOpenFile::save_association()
{
    QString settings_dir= QDir::homeDirPath();
    settings_dir.append("/.KDoodle/");
    QDir sd(settings_dir);
    if (!sd.exists())
    {
         sd.mkdir(settings_dir);
     }
     settings_dir.append("assc.lst");
     QFile associations(settings_dir);
     associations.open( IO_WriteOnly | IO_Append );
     QTextStream stream( &associations);
     QString extension=txt_extension->text();
     extension.append(":");
     extension.append(txt_program->text());
     stream << extension <<"\n";
     associations.close(); 
  }
