/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void QSearchForm::search_string()
{
    list_results->clear();
    QString input = txt_string->text();
    if (input!="")
    {
    doodle_index = new QProcess( this ) ; 
    doodle_index->addArgument( "doodle");
    doodle_index->addArgument( "-i");
    doodle_index->addArgument( input);
    doodle_index->start(); 
    emit search_start();
    emit reset_hit("Searching...");
    qbusyform->show();
    this->setCursor(QCursor(Qt::WaitCursor));
    connect( doodle_index,SIGNAL(readyReadStdout()),this,SLOT(process_data()));
    connect( doodle_index,SIGNAL(processExited()),this, SLOT(enable_input()) );
    txt_string->setEnabled(false);
    btn_search->setEnabled(false);
    list_results->setEnabled(false);
    btn_launch->setEnabled(false);
    btn_reset->setEnabled(false);
    }
    
    else
    {
	QMessageBox::warning(this,"No argument given","You did not provide anything to search for. \nSet an string to look for!");
    }
}

void QSearchForm::process_data()
{
    QString readln;
     while (doodle_index->canReadLineStdout())
    {
      readln=doodle_index->readLineStdout();
      if (!readln.contains("Searching"))
      {
	  list_results->insertItem(readln);
      }
      
    }
}

void QSearchForm::start_file()
{  
    QString  select_file = list_results->currentText();
    connect(this,SIGNAL(shown(const QString &)),filedialog,SLOT(set_file(const QString &)));
    emit shown(select_file);
}


void QSearchForm::init()
{
    filedialog=new QOpenFile(this);    
    filedialog->hide();
    qbusyform = new QBusyForm(this);
    qbusyform->hide();  
    qbusyform->setmsg("Busy searching matching files...");    
}

void QSearchForm::file_selected_send()
{
    QString  a = list_results->currentText();
    emit file_selected(a);
}

void QSearchForm::reset_hit()
{
    emit reset_hit("Ready");
}

void QSearchForm::enable_input()
{
    emit search_stopped();
    txt_string->setEnabled(true);
    btn_search->setEnabled(true);
    list_results->setEnabled(true);
    btn_launch->setEnabled(true);
    btn_reset->setEnabled(true);
    qbusyform->hide();
    this->setCursor(QCursor(Qt::ArrowCursor));
    emit reset_hit("Showing results");
}

